#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <signal.h>
#include <netdb.h>
#include <errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <sys/wait.h>

static int ConnectOutTimed;
static void SubConnectOut(int signum)
{
	signum = ConnectOutTimed++;
}

int main(int argc, const char *const *argv)
{
	int port;
	int Plug, Sock;
	unsigned AddrLen;
	const char *connhost = NULL;
	struct sockaddr_in MyAddr, They;
	struct hostent *HostName;
	if(argc <= 1)
	{
		printf(
			"Pipers - (C) 1992,1999 Bisqwit (http://iki.fi/bisqwit/)\n"
			"Usage: %s %s<port> [-ioe <command>] [...]\n",
			argv[0], strcmp(argv[0], "plis") ? "<host> " : "");
		return -1;
	}
	
	if(isdigit(argv[2][0]))
		connhost = (--argc, *++argv);
		
	signal(SIGCHLD, SIG_IGN);
	signal(SIGPIPE, SIG_IGN);
	
	port = (--argc, atoi(*++argv));
	
	Plug = socket(AF_INET, SOCK_STREAM, 0);
	if(Plug < 0) { perror("socket"); return errno; }
	
	if(connhost)
	{
		HostName = gethostbyname(connhost);
		if(!HostName) { perror("gethostbyname"); return errno; }
		MyAddr.sin_family = AF_INET;
		MyAddr.sin_port = htons(port);
		memcpy(&MyAddr.sin_addr, HostName->h_addr, HostName->h_length);
		signal(SIGABRT, SubConnectOut);
		Sock = fork();
		if(Sock < 0) { perror("fork"); return errno; }
		if(!Sock)
		{
			sleep(5);
			kill(getppid(), SIGABRT);
			_exit(0);
		}
		for(;;)
		{
			if(connect(Plug, (struct sockaddr *)&MyAddr, sizeof(MyAddr)))
			{
				if(errno == EINTR && !ConnectOutTimed)continue;
				if(ConnectOutTimed)errno = ETIMEDOUT;
				perror("connect");
				Plug = -1;
			}
			kill(Sock, SIGKILL);
			signal(SIGABRT, SIG_DFL);
			waitpid(Sock, NULL, 0);
			if(Plug < 0)return errno;
			break;
		}
		Sock = Plug;
		goto Diu;
	}

ReBind:
    MyAddr.sin_port = htons(port);				/* network order */
	MyAddr.sin_family = AF_INET;				/* host byte order */
	MyAddr.sin_addr.s_addr = htonl(INADDR_ANY);	/* auto-fill with my IP, network long  */
    memset((void *)&(MyAddr.sin_zero), 0, 8);	/* zero the rest of the struct */
                       
	if(bind(Plug, (struct sockaddr *)&MyAddr, sizeof(struct sockaddr)))
	{
		if(errno == EADDRINUSE)	/* Address already in use */
		{
			printf("Port %d busy, sleeping 5 seconds and retrying\n", port);
			sleep(5);
			goto ReBind;
		}
		perror("bind");
		return errno;
	}
	
	if(listen(Plug, 10))
	{
		perror("listen");
		return errno;
	}
	
	AddrLen = sizeof(They);
	for(;;)
	{
		int i;
		Sock = accept(Plug, (struct sockaddr *)&They, &AddrLen);
		if(Sock < 0)
		{
			perror("accept");
			sleep(1);
			continue;
		}
		i = fork();
		switch(i)
		{
			case -1:
				perror("fork");
				break;
			case 0:
			{
				int a;
				close(Plug);
Diu:			for(a=1; a<argc; a++)
				{
					const char *s = argv[a];
					if(*s=='-')
					{
						int i=0, o=0, e=0, b;
						while(*++s)
							switch(*s)
							{
								case 'i': i=1; break;
								case 'o': o=1; break;
								case 'e': e=1;
							}
						a++;
						b = connhost ? 0 : fork();
						if(b<0)perror("fork");
						else if(!b)
						{
							if(i)dup2(Sock, 0);
							if(o)dup2(Sock, 1);
							if(e)dup2(Sock, 2);
							execl("/bin/sh", "sh", "-c", argv[a], NULL);
						}
					}
				}
				if(connhost)
				{
					close(Sock);
					goto Quit;
				}
				_exit(0);
			}
			default:
				close(Sock);
		}
	}
Quit:
	return 0;
}
